#include <stdio.h>
#include <stdlib.h>
#include "tri_lisse.h"

void print_tailles( liste_tas* h ) {
    printf("[ ");
    for (noeud_liste_tas* noeud_courant = h->premier_noeud ;
         noeud_courant ;
         noeud_courant = noeud_courant->noeud_suivant )
        printf("(%i, %i) ", min_tas(noeud_courant->tas), noeud_courant->taille);
    printf(" ]");
}

int main( int argc, char** argv ) {
    if (argc != 2) {
        fprintf(stderr, "Usage : %s u0\n", argv[0]);
        exit(EXIT_FAILURE);
    }

    int u0 = atoi(argv[1]);
    liste *e100 = e(u0,100), *e1000 = e(u0,1000), *e10000 = e(u0,10000);
    liste *t_e100 = tri_insertion(e100), *t_e1000 = tri_insertion(e1000),
        *t_e10000 = tri_insertion(e10000);
    liste_tas *h100 = constr_liste_tas(e100), *h1000 = constr_liste_tas(e1000),
        *h10000 = constr_liste_tas(e10000);

    printf("Question 4 : a) %i  b) %i  c) %i \n",
           nth(t_e100,21), nth(t_e1000,144), nth(t_e10000,1212));
    printf("Question 12 : a) ");
    print_tailles(h100);
    printf(" b) ");
    print_tailles(h1000);
    printf(" c) ");
    print_tailles(h10000);
    printf("\n");

    tri_racine(&h100);
    tri_racine(&h1000);
    tri_racine(&h10000);
    printf("Question 16 : a) %i  b) %i  c) %i \n",
           h100->dernier_noeud->tas->racine->valeur,
           h1000->dernier_noeud->tas->racine->valeur,
           h10000->dernier_noeud->tas->racine->valeur );

    libere_liste(e100);
    libere_liste(e1000);
    libere_liste(e10000);
    libere_liste(t_e100);
    libere_liste(t_e1000);
    libere_liste(t_e10000);
    libere_liste_tas(h100);
    libere_liste_tas(h1000);
    libere_liste_tas(h10000);
}
