#ifndef TRI_LISSE_H
#define TRI_LISSE_H

typedef struct noeud_liste {
    int valeur;
    struct noeud_liste* noeud_suivant;
} noeud_liste;

typedef struct liste {
    noeud_liste* premier_noeud;
} liste;

typedef struct noeud_arbre {
    int valeur;
    struct noeud_arbre* fils_gauche;
    struct noeud_arbre* fils_droit;
} noeud_arbre;

typedef struct arbre {
    noeud_arbre* racine;
} arbre;

typedef struct noeud_liste_tas {
    int taille;
    arbre* tas;
    struct noeud_liste_tas* noeud_suivant;
    struct noeud_liste_tas* noeud_precedent;
} noeud_liste_tas;

typedef struct liste_tas {
    noeud_liste_tas* premier_noeud;
    noeud_liste_tas* dernier_noeud;
} liste_tas;

liste* creer_liste_vide();
void libere_liste( liste* l );
int nth( liste* l, int i );
void insere( liste* l, int x );
liste* tri_insertion( liste* l );
liste* e( int u0, int n );
arbre* creer_arbre( int x, arbre* fg, arbre* fd );
void libere_noeud_arbre( noeud_arbre* a );
int min_tas( arbre* a );
int min_quasi( arbre* a );
void percole( arbre* a );
liste_tas* creer_liste_tas();
void libere_liste_tas( liste_tas* h );
void insere_tas(liste_tas* h, arbre* a, int x );
void extrait_tas(liste_tas* h, arbre** a, int* x);
void ajoute( liste_tas* h, int x );
liste_tas* constr_liste_tas( liste* l );
void echange_racine( arbre* a, arbre* b );
void insere_tas_ro ( liste_tas* h, arbre* a, int t );
void tri_racine( liste_tas** h );
int extraire( liste_tas* t);
liste* tri_lisse( liste* l);

#endif
